import static org.junit.Assert.*;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class TestEquation {
    @Test
    public void testNouvelleEquation() {
        Equation eq = new Equation(1, 2);
        assertEquals(1, eq.coefficientDeX(), 0.0001);
        assertEquals(2, eq.constante(), 0.0001);
    }
    @Test
    public void testChangeCoefDeX() {
        Equation eq = new Equation(0, 0);
        assertEquals(0, eq.coefficientDeX(), 0.0001);
        eq.coefficientDeX(3.5);
        assertEquals(3.5, eq.coefficientDeX(), 0.0001);
    }
    @Test
    public void testChangeConstante() {
        Equation eq = new Equation(0, 0);
        assertEquals(0, eq.constante(), 0.0001);
        eq.constante(-2.3);
        assertEquals(-2.3, eq.constante(), 0.0001);
    }
    @Test
    public void test1CalculDeZero() throws ExceptionPasDeZero, ExceptionInfiniteDeZeros {
        Equation eq = new Equation(1, 2);
        assertEquals(-2, eq.zero(), 0.0001);
        eq.coefficientDeX(2);
        assertEquals(-1, eq.zero(), 0.0001);
        eq.constante(0);
        assertEquals(0, eq.zero(), 0.0001);
    }
    @Test (expected = ExceptionPasDeZero.class)
    public void test2CalculDeZero() throws ExceptionPasDeZero, ExceptionInfiniteDeZeros {
        Equation eq = new Equation(0, 1);
        double z = eq.zero();
    }
    @Test (expected = ExceptionInfiniteDeZeros.class)
    public void test3CalculDeZero() throws ExceptionPasDeZero, ExceptionInfiniteDeZeros {
        Equation eq = new Equation(0, 0);
        double z = eq.zero();
    }
    @Test
    public void testCalculValeur() {
        Equation eq = new Equation(2, -3);
        assertEquals(-5, eq.valeur(-1), 0.0001);
        assertEquals(-3, eq.valeur(0), 0.0001);
        assertEquals(-1, eq.valeur(1), 0.0001);
        assertEquals(1, eq.valeur(2), 0.0001);
        assertEquals(7, eq.valeur(5), 0.0001);
    }
    @Test (timeout = 250)
    public void testPerformance() {
        Equation eq = new Equation(-1, 1);
        for(double x = 0; x < 100000; x += 0.01) {
            eq.valeur(x);
        }
    }
}
